> ## Documentation Index
> Fetch the complete documentation index at: https://docs.withorb.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Schedule plan change

> This endpoint can be used to change an existing subscription's plan. It returns the serialized updated subscription object.

The body parameter `change_option` determines when the plan change occurs. Orb supports three options:
- `end_of_subscription_term`: changes the plan at the end of the existing plan's term.
    - Issuing this plan change request for a monthly subscription will keep the existing plan active until the start
      of the subsequent month. Issuing this plan change request for a yearly subscription will keep the existing plan active for
      the full year. Charges incurred in the remaining period will be invoiced as normal.
    - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, so the plan will be
      changed on February 1st, and invoice will be issued on February 1st for the last month of the original plan.
- `immediate`: changes the plan immediately.
    - Subscriptions that have their plan changed with this option will move to the new plan immediately, and be invoiced
      immediately.
    - This invoice will include any usage fees incurred in the billing period up to the change, along with any prorated
      recurring fees for the billing period, if applicable.
    - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, so the plan will be
      changed on January 15th, and an invoice will be issued for the partial month, from January 1 to January 15, on the
      original plan.
- `requested_date`: changes the plan on the requested date (`change_date`).
    - If no timezone is provided, the customer's timezone is used. The `change_date` body parameter is required if this option
      is chosen.
    - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, with a requested
      `change_date` of February 15th, so the plan will be changed on February 15th, and invoices will be issued on February 1st
      and February 15th.

Note that one of `plan_id` or `external_plan_id` is required in the request body for this operation.

## Customize your customer's subscriptions

Prices and adjustments in a plan can be added, removed, or replaced on the subscription when you schedule the plan change. This
is useful when a customer has prices that differ from the default prices for a specific plan.

<Note>
This feature is only available for accounts that have migrated to Subscription Overrides Version 2. You can find your
Subscription Overrides Version at the bottom of your [Plans page](https://app.withorb.com/plans)
</Note>

### Adding Prices

To add prices, provide a list of objects with the key `add_prices`. An object in the list must specify an existing add-on price
with a `price_id` or `external_price_id` field, or create a new add-on price by including an object with the key `price`,
identical to what would be used in the request body for the [create price endpoint](/api-reference/price/create-price). See the
[Price resource](/product-catalog/price-configuration) for the specification of different price model configurations possible
in this object.

If the plan has phases, each object in the list must include a number with `plan_phase_order` key to indicate which phase the
price should be added to.

An object in the list can specify an optional `start_date` and optional `end_date`. If `start_date` is unspecified, the start
of the phase / plan change time will be used. If `end_date` is unspecified, it will finish at the end of the phase / have
no end time.

An object in the list can specify an optional `minimum_amount`, `maximum_amount`, or `discounts`. This will create adjustments
which apply only to this price.

Additionally, an object in the list can specify an optional `reference_id`. This ID can be used to reference this price when
[adding an adjustment](#adding-adjustments) in the same API call. However the ID is _transient_ and cannot be used to refer to
the price in future API calls.

### Removing Prices

To remove prices, provide a list of objects with the key `remove_prices`. An object in the list must specify a plan price with
either a `price_id` or `external_price_id` field.

### Replacing Prices

To replace prices, provide a list of objects with the key `replace_prices`. An object in the list must specify a plan price to
replace with the `replaces_price_id` key, and it must specify a price to replace it with by either referencing an existing
add-on price with a `price_id` or `external_price_id` field, or by creating a new add-on price by including an object with the
key `price`, identical to what would be used in the request body for
the [create price endpoint](/api-reference/price/create-price).
See the [Price resource](/product-catalog/price-configuration) for the specification of different price model configurations
possible in this object.

For fixed fees, an object in the list can supply a `fixed_price_quantity` instead of a `price`, `price_id`, or
`external_price_id` field. This will update only the quantity for the price, similar to the
[Update price quantity](/api-reference/subscription/update-price-quantity) endpoint.

The replacement price will have the same phase, if applicable, and the same start and end dates as the price it replaces.

An object in the list can specify an optional `minimum_amount`, `maximum_amount`, or `discounts`. This will create adjustments
which apply only to this price.

Additionally, an object in the list can specify an optional `reference_id`. This ID can be used to reference the replacement
price when [adding an adjustment](#adding-adjustments) in the same API call. However the ID is _transient_ and cannot be used to
refer to the price in future API calls.

### Adding adjustments

To add adjustments, provide a list of objects with the key `add_adjustments`. An object in the list must include an object with
the key `adjustment`, identical to the adjustment object in the
[add/edit price intervals endpoint](/api-reference/price-interval/add-or-edit-price-intervals).

If the plan has phases, each object in the list must include a number with `plan_phase_order` key to indicate which phase the
adjustment should be added to.

An object in the list can specify an optional `start_date` and optional `end_date`. If `start_date` is unspecified, the start
of the phase / plan change time will be used. If `end_date` is unspecified, it will finish at the end of the phase / have
no end time.

### Removing adjustments

To remove adjustments, provide a list of objects with the key `remove_adjustments`. An object in the list must include a key,
`adjustment_id`, with the ID of the adjustment to be removed.

### Replacing adjustments

To replace adjustments, provide a list of objects with the key `replace_adjustments`. An object in the list must specify a plan
adjustment to replace with the `replaces_adjustment_id` key, and it must specify an adjustment to replace it with by including
an object with the key `adjustment`, identical to the adjustment object in the
[add/edit price intervals endpoint](/api-reference/price-interval/add-or-edit-price-intervals).

The replacement adjustment will have the same phase, if applicable, and the same start and end dates as the adjustment it
replaces.

## Price overrides (DEPRECATED)

<Note>
Price overrides are being phased out in favor adding/removing/replacing prices. (See
[Customize your customer's subscriptions](/api-reference/subscription/schedule-plan-change))
</Note>

Price overrides are used to update some or all prices in a plan for the specific subscription being created. This is
useful when a new customer has negotiated a rate that is unique to the customer.

To override prices, provide a list of objects with the key `price_overrides`. The price object in the list of overrides
is expected to contain the existing price id, the `model_type` and configuration.
(See the [Price resource](/product-catalog/price-configuration)
for the specification of different price model configurations.) The numerical values can be updated, but the billable metric,
cadence, type, and name of a price can not be overridden.

### Maximums, and minimums
Price overrides are used to update some or all prices in the target plan. Minimums and maximums, much like price
overrides, can be useful when a new customer has negotiated a new or different minimum or maximum spend cap than the
default for the plan. The request format for maximums and minimums is the same as those in
[subscription creation](create-subscription).

## Scheduling multiple plan changes
When scheduling multiple plan changes with the same date, the latest plan change on that day takes effect.

## Prorations for in-advance fees
By default, Orb calculates the prorated difference in any fixed fees when making a plan change, adjusting the
customer balance as needed. For details on this behavior, see
[Modifying subscriptions](/product-catalog/modifying-subscriptions#prorations-for-in-advance-fees).



## OpenAPI

````yaml /api-reference/orb-openapi.json post /subscriptions/{subscription_id}/schedule_plan_change
openapi: 3.1.0
info:
  title: API Reference
  description: >-
    Orb's API is built with the following principles in mind:


    1. **Predictable developer experience**: Where applicable, the Orb API uses
    industry-standard patterns such as

    cursor-based pagination and standardized error output. To help with
    debugging in critical API

    actions, the API always strives to provide detailed and actionable error
    messages. Aliases

    such as external customer IDs aid in fast integration times.

    2. **Reliably real time**: Orb's event-based APIs, such as event ingestion
    are designed to handle extremely high

    throughput and scale with concurrent load. Orb also provides a real-time
    event-level credits

    ledger and a highly performant webhooks architecture.

    3. **Flexibility at the forefront**: Features like timezone localization and
    the ability to amend historical usage

    show the flexible nature of the platform.


    You can download the latest OpenAPI spec
    [here](https://api.withorb.com/spec.json) - pass `?version=3.0` for an

    OpenAPI 3.0-compatible spec.
  contact:
    name: Orb, Inc.
    url: https://www.withorb.com/
    email: team@withorb.com
  version: '1.0'
servers:
  - url: https://api.withorb.com/v1
    description: Production server
security:
  - APIKeyAuth: []
tags:
  - name: Alert
    description: >-
      [Alerts within Orb](/product-catalog/configuring-alerts) monitor spending,

      usage, or credit balance and trigger webhooks when a threshold is
      exceeded.


      Alerts created through the API can be scoped to either customers or
      subscriptions.
  - name: Availability
  - name: Coupon
    description: >-
      A coupon represents a reusable discount configuration that can be applied
      either as a fixed or percentage amount to an invoice or subscription.
      Coupons are activated using a redemption code, which applies the discount
      to a subscription or invoice. The duration of a coupon determines how long
      it remains available for use by end users.
  - name: Credit
    description: >-
      The [Credit Ledger Entry resource](/product-catalog/prepurchase) models
      prepaid credits within Orb.
  - name: Credit note
    description: >-
      The [Credit Note](/invoicing/credit-notes) resource represents a credit
      that has been applied to a

      particular invoice.
  - name: Customer
    description: >-
      A customer is a buyer of your products, and the other party to the billing
      relationship.


      In Orb, customers are assigned system generated identifiers automatically,
      but it's often desirable to have these

      match existing identifiers in your system. To avoid having to denormalize
      Orb ID information, you can pass in an

      `external_customer_id` with your own identifier. See

      [Customer ID Aliases](/events-and-metrics/customer-aliases) for further
      information about how these

      aliases work in Orb.


      In addition to having an identifier in your system, a customer may exist
      in a payment provider solution like

      Stripe. Use the `payment_provider_id` and the `payment_provider` enum
      field to express this mapping.


      A customer also has a timezone (from the standard [IANA timezone
      database](https://www.iana.org/time-zones)), which

      defaults to your account's timezone. See [Timezone
      localization](/essentials/timezones) for

      information on what this timezone parameter influences within Orb.
  - name: Dimensional Price Group
  - name: Event
    description: >-
      The [Event](/core-concepts#event) resource represents a usage event that
      has been created for a

      customer. Events are the core of Orb's usage-based billing model, and are
      used to calculate the usage charges for

      a given billing period.
  - name: Invoice
    description: >-
      An [`Invoice`](/core-concepts#invoice) is a fundamental billing entity,
      representing the request for payment for

      a single subscription. This includes a set of line items, which correspond
      to prices in the subscription's plan and

      can represent fixed recurring fees or usage-based fees. They are generated
      at the end of a billing period, or as

      the result of an action, such as a cancellation.
  - name: Item
    description: >-
      The Item resource represents a sellable product or good. Items are
      associated with all line items, billable metrics,

      and prices and are used for defining external sync behavior for invoices
      and tax calculation purposes.
  - name: License
  - name: LicenseType
    description: >-
      The LicenseType resource represents a type of license that can be assigned
      to users.

      License types are used during billing by grouping metrics on the
      configured grouping key.
  - name: Metric
    description: >-
      The Metric resource represents a calculation of a quantity based on
      events.

      Metrics are defined by the query that transforms raw usage events into
      meaningful values for your customers.
  - name: Plan
    description: >-
      The [Plan](/core-concepts#plan-and-price) resource represents a plan that
      can be subscribed to by a

      customer. Plans define the billing behavior of the subscription. You can
      see more about how to configure prices

      in the [Price resource](/reference/price).
  - name: Price
    description: >-
      The Price resource represents a price that can be billed on a
      subscription, resulting in a charge on an invoice in

      the form of an invoice line item. Prices take a quantity and determine an
      amount to bill.


      Orb supports a few different pricing models out of the box. Each of these
      models is serialized differently in a

      given Price object. The model_type field determines the key for the
      configuration object that is present.


      For more on the types of prices, see [the core concepts
      documentation](/core-concepts#plan-and-price)
  - name: Price interval
    description: >-
      The Price Interval resource represents a period of time for which a price
      will bill on a subscription. A

      subscription’s price intervals define its billing behavior.
  - name: Subscription
    description: >-
      A [subscription](/core-concepts#subscription) represents the purchase of a
      plan by a customer.


      By default, subscriptions begin on the day that they're created and renew
      automatically for each billing cycle at

      the cadence that's configured in the plan definition.


      Subscriptions also default to **beginning of month alignment**, which
      means the first invoice issued for the

      subscription will have pro-rated charges between the `start_date` and the
      first of the following month. Subsequent

      billing periods will always start and end on a month boundary (e.g.
      subsequent month starts for monthly billing).


      Depending on the plan configuration, any _flat_ recurring fees will be
      billed either at the beginning (in-advance)

      or end (in-arrears) of each billing cycle. Plans default to **in-advance
      billing**. Usage-based fees are billed in

      arrears as usage is accumulated. In the normal course of events, you can
      expect an invoice to contain usage-based

      charges for the previous period, and a recurring fee for the following
      period.
  - name: Subscription Change
paths:
  /subscriptions/{subscription_id}/schedule_plan_change:
    post:
      tags:
        - Subscription
      summary: Schedule plan change
      description: >-
        This endpoint can be used to change an existing subscription's plan. It
        returns the serialized updated subscription object.


        The body parameter `change_option` determines when the plan change
        occurs. Orb supports three options:

        - `end_of_subscription_term`: changes the plan at the end of the
        existing plan's term.
            - Issuing this plan change request for a monthly subscription will keep the existing plan active until the start
              of the subsequent month. Issuing this plan change request for a yearly subscription will keep the existing plan active for
              the full year. Charges incurred in the remaining period will be invoiced as normal.
            - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, so the plan will be
              changed on February 1st, and invoice will be issued on February 1st for the last month of the original plan.
        - `immediate`: changes the plan immediately.
            - Subscriptions that have their plan changed with this option will move to the new plan immediately, and be invoiced
              immediately.
            - This invoice will include any usage fees incurred in the billing period up to the change, along with any prorated
              recurring fees for the billing period, if applicable.
            - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, so the plan will be
              changed on January 15th, and an invoice will be issued for the partial month, from January 1 to January 15, on the
              original plan.
        - `requested_date`: changes the plan on the requested date
        (`change_date`).
            - If no timezone is provided, the customer's timezone is used. The `change_date` body parameter is required if this option
              is chosen.
            - Example: The plan is billed monthly on the 1st of the month, the request is made on January 15th, with a requested
              `change_date` of February 15th, so the plan will be changed on February 15th, and invoices will be issued on February 1st
              and February 15th.

        Note that one of `plan_id` or `external_plan_id` is required in the
        request body for this operation.


        ## Customize your customer's subscriptions


        Prices and adjustments in a plan can be added, removed, or replaced on
        the subscription when you schedule the plan change. This

        is useful when a customer has prices that differ from the default prices
        for a specific plan.


        <Note>

        This feature is only available for accounts that have migrated to
        Subscription Overrides Version 2. You can find your

        Subscription Overrides Version at the bottom of your [Plans
        page](https://app.withorb.com/plans)

        </Note>


        ### Adding Prices


        To add prices, provide a list of objects with the key `add_prices`. An
        object in the list must specify an existing add-on price

        with a `price_id` or `external_price_id` field, or create a new add-on
        price by including an object with the key `price`,

        identical to what would be used in the request body for the [create
        price endpoint](/api-reference/price/create-price). See the

        [Price resource](/product-catalog/price-configuration) for the
        specification of different price model configurations possible

        in this object.


        If the plan has phases, each object in the list must include a number
        with `plan_phase_order` key to indicate which phase the

        price should be added to.


        An object in the list can specify an optional `start_date` and optional
        `end_date`. If `start_date` is unspecified, the start

        of the phase / plan change time will be used. If `end_date` is
        unspecified, it will finish at the end of the phase / have

        no end time.


        An object in the list can specify an optional `minimum_amount`,
        `maximum_amount`, or `discounts`. This will create adjustments

        which apply only to this price.


        Additionally, an object in the list can specify an optional
        `reference_id`. This ID can be used to reference this price when

        [adding an adjustment](#adding-adjustments) in the same API call.
        However the ID is _transient_ and cannot be used to refer to

        the price in future API calls.


        ### Removing Prices


        To remove prices, provide a list of objects with the key
        `remove_prices`. An object in the list must specify a plan price with

        either a `price_id` or `external_price_id` field.


        ### Replacing Prices


        To replace prices, provide a list of objects with the key
        `replace_prices`. An object in the list must specify a plan price to

        replace with the `replaces_price_id` key, and it must specify a price to
        replace it with by either referencing an existing

        add-on price with a `price_id` or `external_price_id` field, or by
        creating a new add-on price by including an object with the

        key `price`, identical to what would be used in the request body for

        the [create price endpoint](/api-reference/price/create-price).

        See the [Price resource](/product-catalog/price-configuration) for the
        specification of different price model configurations

        possible in this object.


        For fixed fees, an object in the list can supply a
        `fixed_price_quantity` instead of a `price`, `price_id`, or

        `external_price_id` field. This will update only the quantity for the
        price, similar to the

        [Update price
        quantity](/api-reference/subscription/update-price-quantity) endpoint.


        The replacement price will have the same phase, if applicable, and the
        same start and end dates as the price it replaces.


        An object in the list can specify an optional `minimum_amount`,
        `maximum_amount`, or `discounts`. This will create adjustments

        which apply only to this price.


        Additionally, an object in the list can specify an optional
        `reference_id`. This ID can be used to reference the replacement

        price when [adding an adjustment](#adding-adjustments) in the same API
        call. However the ID is _transient_ and cannot be used to

        refer to the price in future API calls.


        ### Adding adjustments


        To add adjustments, provide a list of objects with the key
        `add_adjustments`. An object in the list must include an object with

        the key `adjustment`, identical to the adjustment object in the

        [add/edit price intervals
        endpoint](/api-reference/price-interval/add-or-edit-price-intervals).


        If the plan has phases, each object in the list must include a number
        with `plan_phase_order` key to indicate which phase the

        adjustment should be added to.


        An object in the list can specify an optional `start_date` and optional
        `end_date`. If `start_date` is unspecified, the start

        of the phase / plan change time will be used. If `end_date` is
        unspecified, it will finish at the end of the phase / have

        no end time.


        ### Removing adjustments


        To remove adjustments, provide a list of objects with the key
        `remove_adjustments`. An object in the list must include a key,

        `adjustment_id`, with the ID of the adjustment to be removed.


        ### Replacing adjustments


        To replace adjustments, provide a list of objects with the key
        `replace_adjustments`. An object in the list must specify a plan

        adjustment to replace with the `replaces_adjustment_id` key, and it must
        specify an adjustment to replace it with by including

        an object with the key `adjustment`, identical to the adjustment object
        in the

        [add/edit price intervals
        endpoint](/api-reference/price-interval/add-or-edit-price-intervals).


        The replacement adjustment will have the same phase, if applicable, and
        the same start and end dates as the adjustment it

        replaces.


        ## Price overrides (DEPRECATED)


        <Note>

        Price overrides are being phased out in favor adding/removing/replacing
        prices. (See

        [Customize your customer's
        subscriptions](/api-reference/subscription/schedule-plan-change))

        </Note>


        Price overrides are used to update some or all prices in a plan for the
        specific subscription being created. This is

        useful when a new customer has negotiated a rate that is unique to the
        customer.


        To override prices, provide a list of objects with the key
        `price_overrides`. The price object in the list of overrides

        is expected to contain the existing price id, the `model_type` and
        configuration.

        (See the [Price resource](/product-catalog/price-configuration)

        for the specification of different price model configurations.) The
        numerical values can be updated, but the billable metric,

        cadence, type, and name of a price can not be overridden.


        ### Maximums, and minimums

        Price overrides are used to update some or all prices in the target
        plan. Minimums and maximums, much like price

        overrides, can be useful when a new customer has negotiated a new or
        different minimum or maximum spend cap than the

        default for the plan. The request format for maximums and minimums is
        the same as those in

        [subscription creation](create-subscription).


        ## Scheduling multiple plan changes

        When scheduling multiple plan changes with the same date, the latest
        plan change on that day takes effect.


        ## Prorations for in-advance fees

        By default, Orb calculates the prorated difference in any fixed fees
        when making a plan change, adjusting the

        customer balance as needed. For details on this behavior, see

        [Modifying
        subscriptions](/product-catalog/modifying-subscriptions#prorations-for-in-advance-fees).
      operationId: schedule-plan-change
      parameters:
        - required: true
          style: simple
          schema:
            type: string
          name: subscription_id
          in: path
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubscriptionPlanChange'
        required: true
      responses:
        '200':
          description: OK
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MutatedSubscription'
        '400':
          description: Bad Request
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/400Error'
        '401':
          description: Unauthorized
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/401Error'
        '404':
          description: Not Found
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/404Error'
        '409':
          description: Conflict
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/409Error'
        '413':
          description: Content Too Large
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/413Error'
        '429':
          description: Too Many Requests
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/429Error'
        '500':
          description: Internal Server Error
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/500Error'
components:
  schemas:
    SubscriptionPlanChange:
      properties:
        usage_customer_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Usage Customer Ids
          description: >-
            A list of customer IDs whose usage events will be aggregated and
            billed under this subscription. By default, a subscription only
            considers usage events associated with its attached customer's
            customer_id. When usage_customer_ids is provided, the subscription
            includes usage events from the specified customers only. Provided
            usage_customer_ids must be either the customer for this subscription
            itself, or any of that customer's children.
        filter:
          oneOf:
            - type: string
            - type: 'null'
          title: Filter
          description: >-
            An additional filter to apply to usage queries. This filter must be
            expressed as a boolean [computed
            property](/extensibility/advanced-metrics#computed-properties). If
            null, usage queries will not include any additional filter.
          examples:
            - my_property > 100 AND my_other_property = 'bar'
            - my_property = 'foo'
        plan_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Plan Id
          description: >-
            The plan that the given subscription should be switched to. Note
            that either this property or `external_plan_id` must be specified.
          examples:
            - ZMwNQefe7J3ecf7W
        external_plan_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Plan Id
          description: >-
            The external_plan_id of the plan that the given subscription should
            be switched to. Note that either this property or `plan_id` must be
            specified.
          examples:
            - ZMwNQefe7J3ecf7W
        price_overrides:
          oneOf:
            - items:
                deprecated: true
              type: array
            - type: 'null'
          title: Price Overrides
          description: Optionally provide a list of overrides for prices on the plan
          deprecated: true
        per_credit_overage_amount:
          oneOf:
            - type: number
            - type: 'null'
          title: Per Credit Overage Amount
          deprecated: true
        credits_overage_rate:
          oneOf:
            - type: number
            - type: 'null'
          title: Credits Overage Rate
          deprecated: true
        trial_duration_days:
          oneOf:
            - type: integer
              exclusiveMaximum: 1000000
              minimum: 0
            - type: 'null'
          title: Trial Duration Days
          description: >-
            The duration of the trial period in days. If not provided, this
            defaults to the value specified in the plan. If `0` is provided, the
            trial on the plan will be skipped.
        net_terms:
          oneOf:
            - type: integer
            - type: 'null'
          title: Net Terms
          description: >-
            The net terms determines the difference between the invoice date and
            the issue date for the invoice. If you intend the invoice to be due
            on issue, set this to 0. If not provided, this defaults to the value
            specified in the plan.
        auto_collection:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Auto Collection
          description: >-
            Determines whether issued invoices for this subscription will
            automatically be charged with the saved payment method on the due
            date. If not specified, this defaults to the behavior configured for
            this customer.
        default_invoice_memo:
          oneOf:
            - type: string
            - type: 'null'
          title: Default Invoice Memo
          description: >-
            Determines the default memo on this subscription's invoices. Note
            that if this is not provided, it is determined by the plan
            configuration.
        coupon_redemption_code:
          oneOf:
            - type: string
            - type: 'null'
          title: Coupon Redemption Code
          description: >-
            Redemption code to be used for this subscription. If the coupon
            cannot be found by its redemption code, or cannot be redeemed, an
            error response will be returned and the subscription creation or
            plan change will not be scheduled.
        invoicing_threshold:
          oneOf:
            - type: string
            - type: 'null'
          title: Invoicing Threshold
          description: >-
            When this subscription's accrued usage reaches this threshold, an
            invoice will be issued for the subscription. If not specified,
            invoices will only be issued at the end of the billing period.
          examples:
            - '10.00'
        initial_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Initial Phase Order
          description: The phase of the plan to start with
          examples:
            - 2
        add_prices:
          oneOf:
            - items:
                $ref: '#/components/schemas/AddSubscriptionPriceParams'
              type: array
            - type: 'null'
          title: Add Prices
          description: >-
            Additional prices to be added to the subscription. (Only available
            for accounts that have migrated off of legacy subscription
            overrides)
        remove_prices:
          oneOf:
            - items:
                $ref: '#/components/schemas/RemoveSubscriptionPriceParams'
              type: array
            - type: 'null'
          title: Remove Prices
          description: >-
            Plan prices to be removed from the subscription. (Only available for
            accounts that have migrated off of legacy subscription overrides)
        replace_prices:
          oneOf:
            - items:
                $ref: '#/components/schemas/ReplaceSubscriptionPriceParams'
              type: array
            - type: 'null'
          title: Replace Prices
          description: >-
            Plan prices to be replaced with additional prices on the
            subscription. (Only available for accounts that have migrated off of
            legacy subscription overrides)
        add_adjustments:
          oneOf:
            - items:
                $ref: '#/components/schemas/AddSubscriptionAdjustmentParams'
              type: array
            - type: 'null'
          title: Add Adjustments
          description: >-
            Additional adjustments to be added to the subscription. (Only
            available for accounts that have migrated off of legacy subscription
            overrides)
        remove_adjustments:
          oneOf:
            - items:
                $ref: '#/components/schemas/RemoveSubscriptionAdjustmentParams'
              type: array
            - type: 'null'
          title: Remove Adjustments
          description: >-
            Plan adjustments to be removed from the subscription. (Only
            available for accounts that have migrated off of legacy subscription
            overrides)
        replace_adjustments:
          oneOf:
            - items:
                $ref: '#/components/schemas/ReplaceSubscriptionAdjustmentParams'
              type: array
            - type: 'null'
          title: Replace Adjustments
          description: >-
            Plan adjustments to be replaced with additional adjustments on the
            subscription. (Only available for accounts that have migrated off of
            legacy subscription overrides)
        change_option:
          type: string
          enum:
            - requested_date
            - end_of_subscription_term
            - immediate
          title: Change Option
        change_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Change Date
          description: >-
            The date that the plan change should take effect. This parameter can
            only be passed if the `change_option` is `requested_date`. If a date
            with no time is passed, the plan change will happen at midnight in
            the customer's timezone.
          examples:
            - '2017-07-21T17:32:28Z'
            - '2017-07-21'
        align_billing_with_plan_change_date:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Align Billing With Plan Change Date
          description: >-
            [DEPRECATED] Use billing_cycle_alignment instead. Reset billing
            periods to be aligned with the plan change's effective date.
        billing_cycle_alignment:
          oneOf:
            - type: string
              enum:
                - unchanged
                - plan_change_date
                - start_of_month
            - type: 'null'
          title: Billing Cycle Alignment
          description: >-
            Reset billing periods to be aligned with the plan change's effective
            date or start of the month. Defaults to `unchanged` which keeps
            subscription's existing billing cycle alignment.
          default: unchanged
        plan_version_number:
          oneOf:
            - type: integer
            - type: 'null'
          title: Plan Version Number
          description: >-
            Specifies which version of the plan to change to. If null, the
            default version will be used.
        billing_cycle_anchor_configuration:
          oneOf:
            - $ref: '#/components/schemas/BillingCycleAnchorConfiguration'
            - type: 'null'
      additionalProperties: false
      type: object
      required:
        - change_option
      title: SubscriptionPlanChange
    MutatedSubscription:
      properties:
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        customer:
          $ref: '#/components/schemas/Customer'
        plan:
          oneOf:
            - $ref: '#/components/schemas/Plan'
            - type: 'null'
        name:
          type: string
          title: Name
          description: The name of the subscription.
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The date Orb starts billing for this subscription.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The date Orb stops billing for this subscription.
        created_at:
          type: string
          format: date-time
          title: Created At
        current_billing_period_start_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Current Billing Period Start Date
          description: >-
            The start date of the current billing period. This is an inclusive
            timestamp; the instant returned is exactly the beginning of the
            billing period. Set to null if the subscription is not currently
            active.
        current_billing_period_end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Current Billing Period End Date
          description: >-
            The end of the current billing period. This is an exclusive
            timestamp, such that the instant returned is not part of the billing
            period. Set to null for subscriptions that are not currently active.
        status:
          type: string
          enum:
            - active
            - ended
            - upcoming
          title: Status
        trial_info:
          $ref: '#/components/schemas/SubscriptionTrialInfo'
        active_plan_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Active Plan Phase Order
          description: >-
            The current plan phase that is active, only if the subscription's
            plan has phases.
        fixed_fee_quantity_schedule:
          items:
            $ref: '#/components/schemas/FixedFeeQuantityScheduleEntry'
          type: array
          title: Fixed Fee Quantity Schedule
        default_invoice_memo:
          oneOf:
            - type: string
            - type: 'null'
          title: Default Invoice Memo
          description: >-
            Determines the default memo on this subscriptions' invoices. Note
            that if this is not provided, it is determined by the plan
            configuration.
        auto_collection:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Auto Collection
          description: >-
            Determines whether issued invoices for this subscription will
            automatically be charged with the saved payment method on the due
            date. This property defaults to the plan's behavior. If null,
            defaults to the customer's setting.
        net_terms:
          type: integer
          title: Net Terms
          description: >-
            Determines the difference between the invoice issue date for
            subscription invoices as the date that they are due. A value of `0`
            here represents that the invoice is due on issue, whereas a value of
            `30` represents that the customer has a month to pay the invoice.
        redeemed_coupon:
          oneOf:
            - $ref: '#/components/schemas/CouponRedemption'
            - type: 'null'
        billing_cycle_day:
          type: integer
          maximum: 31
          minimum: 1
          title: Billing Cycle Day
          description: >-
            The day of the month on which the billing cycle is anchored. If the
            maximum number of days in a month is greater than this value, the
            last day of the month is the billing cycle day (e.g.
            billing_cycle_day=31 for April means the billing period begins on
            the 30th.
        billing_cycle_anchor_configuration:
          $ref: '#/components/schemas/BillingCycleAnchorConfiguration'
        invoicing_threshold:
          oneOf:
            - type: string
            - type: 'null'
          title: Invoicing Threshold
        price_intervals:
          items:
            $ref: '#/components/schemas/PriceInterval'
          type: array
          title: Price Intervals
          description: The price intervals for this subscription.
        adjustment_intervals:
          items:
            $ref: '#/components/schemas/AdjustmentInterval'
          type: array
          title: Adjustment Intervals
          description: >-
            The adjustment intervals for this subscription sorted by the
            start_date of the adjustment interval.
        discount_intervals:
          items:
            oneOf:
              - $ref: '#/components/schemas/AmountDiscountInterval'
              - $ref: '#/components/schemas/PercentageDiscountInterval'
              - $ref: '#/components/schemas/UsageDiscountInterval'
              - $ref: '#/components/schemas/TieredPercentageDiscountInterval'
            discriminator:
              propertyName: discount_type
              mapping:
                amount:
                  $ref: '#/components/schemas/AmountDiscountInterval'
                percentage:
                  $ref: '#/components/schemas/PercentageDiscountInterval'
                tiered_percentage:
                  $ref: '#/components/schemas/TieredPercentageDiscountInterval'
                usage:
                  $ref: '#/components/schemas/UsageDiscountInterval'
          type: array
          title: Discount Intervals
          description: >-
            The discount intervals for this subscription sorted by the
            start_date. This field is deprecated in favor of
            `adjustment_intervals`.
          deprecated: true
        minimum_intervals:
          items:
            $ref: '#/components/schemas/MinimumInterval'
          type: array
          title: Minimum Intervals
          description: >-
            The minimum intervals for this subscription sorted by the
            start_date. This field is deprecated in favor of
            `adjustment_intervals`.
          deprecated: true
        maximum_intervals:
          items:
            $ref: '#/components/schemas/MaximumInterval'
          type: array
          title: Maximum Intervals
          description: >-
            The maximum intervals for this subscription sorted by the
            start_date. This field is deprecated in favor of
            `adjustment_intervals`.
          deprecated: true
        pending_subscription_change:
          oneOf:
            - $ref: '#/components/schemas/SubscriptionChangeMinified'
            - type: 'null'
          description: A pending subscription change if one exists on this subscription.
        changed_resources:
          oneOf:
            - $ref: '#/components/schemas/ChangedSubscriptionResources'
            - type: 'null'
          description: >-
            The resources that were changed as part of this operation. Only
            present when fetched through the subscription changes API or if the
            `include_changed_resources` parameter was passed in the request.
      type: object
      required:
        - metadata
        - id
        - customer
        - plan
        - name
        - start_date
        - end_date
        - created_at
        - current_billing_period_start_date
        - current_billing_period_end_date
        - status
        - trial_info
        - active_plan_phase_order
        - fixed_fee_quantity_schedule
        - default_invoice_memo
        - auto_collection
        - net_terms
        - redeemed_coupon
        - billing_cycle_day
        - billing_cycle_anchor_configuration
        - invoicing_threshold
        - price_intervals
        - adjustment_intervals
        - discount_intervals
        - minimum_intervals
        - maximum_intervals
        - pending_subscription_change
      title: MutatedSubscription
    400Error:
      oneOf:
        - $ref: '#/components/schemas/ConstraintViolationError'
        - $ref: '#/components/schemas/DuplicateResourceCreationError'
        - $ref: '#/components/schemas/RequestValidationError'
    401Error:
      $ref: '#/components/schemas/AuthorizationError'
      title: 401Error
    404Error:
      oneOf:
        - $ref: '#/components/schemas/FeatureNotAvailableError'
        - $ref: '#/components/schemas/ResourceNotFoundError'
        - $ref: '#/components/schemas/URLNotFound'
    409Error:
      $ref: '#/components/schemas/IdempotencyRequestMismatch'
      title: 409Error
    413Error:
      oneOf:
        - $ref: '#/components/schemas/RequestTooLargeError'
        - $ref: '#/components/schemas/ResourceTooLargeError'
        - $ref: '#/components/schemas/TooManyResultsError'
    429Error:
      $ref: '#/components/schemas/TooManyRequests'
      title: 429Error
    500Error:
      $ref: '#/components/schemas/ServerError'
      title: 500Error
    AddSubscriptionPriceParams:
      properties:
        price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Price Id
          description: The id of the price to add to the subscription.
          examples:
            - h74gfhdjvn7ujokd
        external_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Price Id
          description: The external price id of the price to add to the subscription.
          examples:
            - external_price_id
        price:
          oneOf:
            - $ref: '#/components/schemas/NewSubscriptionPrice'
            - type: 'null'
          description: The definition of a new price to create and add to the subscription.
        allocation_price:
          oneOf:
            - $ref: '#/components/schemas/NewAllocationPrice'
            - type: 'null'
          description: >-
            The definition of a new allocation price to create and add to the
            subscription.
        start_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Start Date
          description: >-
            The start date of the price interval. This is the date that the
            price will start billing on the subscription. If null, billing will
            start when the phase or subscription starts.
          examples:
            - '2023-05-01'
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: >-
            The end date of the price interval. This is the date that the price
            will stop billing on the subscription. If null, billing will end
            when the phase or subscription ends.
          examples:
            - '2023-07-10'
        plan_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Plan Phase Order
          description: The phase to add this price to.
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's minimum
            amount for this price.
          deprecated: true
          examples:
            - '1.23'
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's maximum
            amount for this price.
          deprecated: true
          examples:
            - '1.23'
        discounts:
          oneOf:
            - items:
                $ref: '#/components/schemas/DiscountOverride'
              type: array
            - type: 'null'
          title: Discounts
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's
            discounts for this price.
          deprecated: true
        metric_parameter_overrides:
          oneOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Metric Parameter Overrides
          description: >-
            Override values for parameterized billable metric variables. Keys
            are parameter names, values are the override values.
      type: object
      title: AddSubscriptionPriceParams
    RemoveSubscriptionPriceParams:
      properties:
        price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Price Id
          description: The id of the price to remove on the subscription.
          examples:
            - h74gfhdjvn7ujokd
        external_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Price Id
          description: The external price id of the price to remove on the subscription.
          examples:
            - external_price_id
      type: object
      title: RemoveSubscriptionPriceParams
    ReplaceSubscriptionPriceParams:
      properties:
        price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Price Id
          description: The id of the price to add to the subscription.
          examples:
            - h74gfhdjvn7ujokd
        external_price_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Price Id
          description: The external price id of the price to add to the subscription.
          examples:
            - external_price_id
        price:
          oneOf:
            - $ref: '#/components/schemas/NewSubscriptionPrice'
            - type: 'null'
          description: The definition of a new price to create and add to the subscription.
        allocation_price:
          oneOf:
            - $ref: '#/components/schemas/NewAllocationPrice'
            - type: 'null'
          description: >-
            The definition of a new allocation price to create and add to the
            subscription.
        fixed_price_quantity:
          oneOf:
            - type: number
            - type: 'null'
          title: Fixed Price Quantity
          description: The new quantity of the price, if the price is a fixed price.
          examples:
            - 2
        replaces_price_id:
          type: string
          title: Replaces Price Id
          description: The id of the price on the plan to replace in the subscription.
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's minimum
            amount for the replacement price.
          deprecated: true
          examples:
            - '1.23'
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's maximum
            amount for the replacement price.
          deprecated: true
          examples:
            - '1.23'
        discounts:
          oneOf:
            - items:
                $ref: '#/components/schemas/DiscountOverride'
              type: array
            - type: 'null'
          title: Discounts
          description: >-
            [DEPRECATED] Use add_adjustments instead. The subscription's
            discounts for the replacement price.
          deprecated: true
        metric_parameter_overrides:
          oneOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Metric Parameter Overrides
          description: >-
            Override values for parameterized billable metric variables. Keys
            are parameter names, values are the override values.
      type: object
      required:
        - replaces_price_id
      title: ReplaceSubscriptionPriceParams
    AddSubscriptionAdjustmentParams:
      properties:
        adjustment:
          $ref: '#/components/schemas/NewAdjustment'
          description: >-
            The definition of a new adjustment to create and add to the
            subscription.
        start_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Start Date
          description: >-
            The start date of the adjustment interval. This is the date that the
            adjustment will start affecting prices on the subscription. If null,
            the adjustment will start when the phase or subscription starts.
          examples:
            - '2023-05-01'
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: >-
            The end date of the adjustment interval. This is the date that the
            adjustment will stop affecting prices on the subscription.
          examples:
            - '2023-07-10'
        plan_phase_order:
          oneOf:
            - type: integer
            - type: 'null'
          title: Plan Phase Order
          description: The phase to add this adjustment to.
      type: object
      required:
        - adjustment
      title: AddSubscriptionAdjustmentParams
    RemoveSubscriptionAdjustmentParams:
      properties:
        adjustment_id:
          type: string
          title: Adjustment Id
          description: The id of the adjustment to remove on the subscription.
          examples:
            - h74gfhdjvn7ujokd
      type: object
      required:
        - adjustment_id
      title: RemoveSubscriptionAdjustmentParams
    ReplaceSubscriptionAdjustmentParams:
      properties:
        adjustment:
          $ref: '#/components/schemas/NewAdjustment'
          description: >-
            The definition of a new adjustment to create and add to the
            subscription.
        replaces_adjustment_id:
          type: string
          title: Replaces Adjustment Id
          description: The id of the adjustment on the plan to replace in the subscription.
      type: object
      required:
        - adjustment
        - replaces_adjustment_id
      title: ReplaceSubscriptionAdjustmentParams
    BillingCycleAnchorConfiguration:
      properties:
        day:
          type: integer
          maximum: 31
          minimum: 1
          title: Day
          description: >-
            The day of the month on which the billing cycle is anchored. If the
            maximum number of days in a month is greater than this value, the
            last day of the month is the billing cycle day (e.g.
            billing_cycle_day=31 for April means the billing period begins on
            the 30th.
        month:
          oneOf:
            - type: integer
              maximum: 12
              minimum: 1
            - type: 'null'
          title: Month
          description: >-
            The month on which the billing cycle is anchored (e.g. a quarterly
            price anchored in February would have cycles starting February, May,
            August, and November).
        year:
          oneOf:
            - type: integer
            - type: 'null'
          title: Year
          description: >-
            The year on which the billing cycle is anchored (e.g. a 2 year
            billing cycle anchored on 2021 would have cycles starting on 2021,
            2023, 2025, etc.).
      type: object
      required:
        - day
      title: BillingCycleAnchorConfiguration
    Customer:
      properties:
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        external_customer_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Customer Id
          description: >-
            An optional user-defined ID for this customer resource, used
            throughout the system as an alias for this Customer. Use this field
            to identify a customer by an existing identifier in your system.
        name:
          type: string
          title: Name
          description: The full name of the customer
        email:
          type: string
          title: Email
          description: >-
            A valid customer email, to be used for notifications. When Orb
            triggers payment through a payment gateway, this email will be used
            for any automatically issued receipts.
        timezone:
          type: string
          title: Timezone
          description: >-
            A timezone identifier from the IANA timezone database, such as
            "America/Los_Angeles". This "defaults to your account's timezone if
            not set. This cannot be changed after customer creation.
        payment_provider_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Payment Provider Id
          description: >-
            The ID of this customer in an external payments solution, such as
            Stripe. This is used for creating charges or invoices in the
            external system via Orb.
        payment_provider:
          oneOf:
            - type: string
              enum:
                - quickbooks
                - bill.com
                - stripe_charge
                - stripe_invoice
                - netsuite
                - adyen
            - type: 'null'
          title: Payment Provider
          description: >-
            This is used for creating charges or invoices in an external system
            via Orb. When not in test mode, the connection must first be
            configured in the Orb webapp.
        created_at:
          type: string
          format: date-time
          title: Created At
        shipping_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        billing_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        balance:
          type: string
          title: Balance
          description: The customer's current balance in their currency.
        currency:
          oneOf:
            - type: string
            - type: 'null'
          title: Currency
        tax_id:
          oneOf:
            - $ref: '#/components/schemas/CustomerTaxId'
            - type: 'null'
        auto_collection:
          type: boolean
          title: Auto Collection
        exempt_from_automated_tax:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Exempt From Automated Tax
        email_delivery:
          type: boolean
          title: Email Delivery
        auto_issuance:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Auto Issuance
          description: >-
            Whether invoices for this customer should be automatically issued.
            If true, invoices will be automatically issued. If false, invoices
            will require manual approval. If null, inherits the account-level
            setting.
        additional_emails:
          items:
            type: string
          type: array
          title: Additional Emails
        portal_url:
          oneOf:
            - type: string
            - type: 'null'
          title: Portal Url
          description: >-
            Deprecated. Returns the URL of the most recent non-expired portal
            link, or null. When the account has opted into customer portal
            sessions, this field always returns null. Use POST
            /v1/customers/{id}/portal_sessions to mint short-lived portal
            session URLs.
        accounting_sync_configuration:
          oneOf:
            - $ref: '#/components/schemas/AccountingSyncConfiguration'
            - type: 'null'
        reporting_configuration:
          oneOf:
            - $ref: '#/components/schemas/ReportingConfiguration'
            - type: 'null'
        payment_configuration:
          oneOf:
            - $ref: '#/components/schemas/PaymentConfiguration'
            - type: 'null'
          description: >-
            Payment configuration for the customer, applicable when using Orb
            Invoicing with a supported payment provider such as Stripe.
        default_payment_method:
          oneOf:
            - $ref: '#/components/schemas/PaymentMethod'
            - type: 'null'
          description: The customer's default payment method, or null if none is set.
        hierarchy:
          $ref: '#/components/schemas/CustomerHierarchy'
          description: The hierarchical relationships for this customer.
        automatic_tax_enabled:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Automatic Tax Enabled
          description: >-
            Whether automatic tax calculation is enabled for this customer. This
            field is nullable for backwards compatibility but will always return
            a boolean value.
      type: object
      required:
        - metadata
        - id
        - external_customer_id
        - name
        - email
        - timezone
        - payment_provider_id
        - payment_provider
        - created_at
        - shipping_address
        - billing_address
        - balance
        - currency
        - tax_id
        - auto_collection
        - exempt_from_automated_tax
        - email_delivery
        - auto_issuance
        - additional_emails
        - portal_url
        - hierarchy
      title: Customer
      description: >-
        A customer is a buyer of your products, and the other party to the
        billing relationship.


        In Orb, customers are assigned system generated identifiers
        automatically, but it's often desirable to have these

        match existing identifiers in your system. To avoid having to
        denormalize Orb ID information, you can pass in an

        `external_customer_id` with your own identifier. See

        [Customer ID Aliases](/events-and-metrics/customer-aliases) for further
        information about how these

        aliases work in Orb.


        In addition to having an identifier in your system, a customer may exist
        in a payment provider solution like

        Stripe. Use the `payment_provider_id` and the `payment_provider` enum
        field to express this mapping.


        A customer also has a timezone (from the standard [IANA timezone
        database](https://www.iana.org/time-zones)), which

        defaults to your account's timezone. See [Timezone
        localization](/essentials/timezones) for

        information on what this timezone parameter influences within Orb.
    Plan:
      properties:
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          type: string
          title: Description
        maximum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Maximum Amount
          deprecated: true
        minimum_amount:
          oneOf:
            - type: string
            - type: 'null'
          title: Minimum Amount
          deprecated: true
        created_at:
          type: string
          format: date-time
          title: Created At
        status:
          type: string
          enum:
            - active
            - archived
            - draft
          title: Status
        maximum:
          oneOf:
            - $ref: '#/components/schemas/Maximum'
            - type: 'null'
          deprecated: true
        minimum:
          oneOf:
            - $ref: '#/components/schemas/Minimum'
            - type: 'null'
          deprecated: true
        discount:
          oneOf:
            - $ref: '#/components/schemas/Discount'
            - type: 'null'
          deprecated: true
        product:
          $ref: '#/components/schemas/Product'
        version:
          type: integer
          title: Version
        trial_config:
          $ref: '#/components/schemas/TrialConfig'
        plan_phases:
          oneOf:
            - items:
                $ref: '#/components/schemas/PlanPhase'
              type: array
            - type: 'null'
          title: Plan Phases
        base_plan:
          oneOf:
            - $ref: '#/components/schemas/PlanMinified'
            - type: 'null'
          description: >-
            Legacy field representing the parent plan if the current plan is a
            'child plan', overriding prices from the parent.
          deprecated: true
        base_plan_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Base Plan Id
          description: >-
            Legacy field representing the parent plan ID if the current plan is
            a 'child plan', overriding prices from the parent.
          deprecated: true
        external_plan_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Plan Id
          description: >-
            An optional user-defined ID for this plan resource, used throughout
            the system as an alias for this Plan. Use this field to identify a
            plan by an existing identifier in your system.
        currency:
          type: string
          title: Currency
          description: >-
            An ISO 4217 currency string or custom pricing unit (`credits`) for
            this plan's prices.
          deprecated: true
        invoicing_currency:
          type: string
          title: Invoicing Currency
          description: >-
            An ISO 4217 currency string for which this plan is billed in.
            Matches `currency` unless `currency` is a custom pricing unit.
        net_terms:
          oneOf:
            - type: integer
            - type: 'null'
          title: Net Terms
          description: >-
            Determines the difference between the invoice issue date and the due
            date. A value of "0" here signifies that invoices are due on issue,
            whereas a value of "30" means that the customer has a month to pay
            the invoice before its overdue. Note that individual subscriptions
            or invoices may set a different net terms configuration.
        default_invoice_memo:
          oneOf:
            - type: string
            - type: 'null'
          title: Default Invoice Memo
          description: >-
            The default memo text on the invoices corresponding to subscriptions
            on this plan. Note that each subscription may configure its own
            memo.
        prices:
          items:
            $ref: '#/components/schemas/Price'
          type: array
          uniqueItems: true
          title: Prices
          description: >-
            Prices for this plan. If the plan has phases, this includes prices
            across all phases of the plan.
        adjustments:
          items:
            $ref: '#/components/schemas/Adjustment'
          type: array
          uniqueItems: true
          title: Adjustments
          description: >-
            Adjustments for this plan. If the plan has phases, this includes
            adjustments across all phases of the plan.
      type: object
      required:
        - metadata
        - id
        - name
        - description
        - maximum_amount
        - minimum_amount
        - created_at
        - status
        - maximum
        - minimum
        - discount
        - product
        - version
        - trial_config
        - plan_phases
        - base_plan
        - base_plan_id
        - external_plan_id
        - currency
        - invoicing_currency
        - net_terms
        - default_invoice_memo
        - prices
        - adjustments
      title: Plan
      description: >-
        The [Plan](/core-concepts#plan-and-price) resource represents a plan
        that can be subscribed to by a

        customer. Plans define the billing behavior of the subscription. You can
        see more about how to configure prices

        in the [Price resource](/reference/price).
    SubscriptionTrialInfo:
      properties:
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
      type: object
      required:
        - end_date
      title: SubscriptionTrialInfo
    FixedFeeQuantityScheduleEntry:
      properties:
        price_id:
          type: string
          title: Price Id
        start_date:
          type: string
          format: date-time
          title: Start Date
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
        quantity:
          type: number
          title: Quantity
      type: object
      required:
        - price_id
        - start_date
        - end_date
        - quantity
      title: FixedFeeQuantityScheduleEntry
    CouponRedemption:
      properties:
        coupon_id:
          type: string
          title: Coupon Id
        start_date:
          type: string
          format: date-time
          title: Start Date
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
      type: object
      required:
        - coupon_id
        - start_date
        - end_date
      title: CouponRedemption
    PriceInterval:
      properties:
        id:
          type: string
          title: Id
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: >-
            The start date of the price interval. This is the date that Orb
            starts billing for this price.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: >-
            The end date of the price interval. This is the date that Orb stops
            billing for this price.
        price:
          $ref: '#/components/schemas/Price'
        billing_cycle_day:
          type: integer
          title: Billing Cycle Day
          description: The day of the month that Orb bills for this price
        can_defer_billing:
          type: boolean
          title: Can Defer Billing
          description: >-
            For in-arrears prices. If true, and the price interval ends
            mid-cycle, the final line item will be deferred to the next
            scheduled invoice instead of being billed mid-cycle.
        fixed_fee_quantity_transitions:
          oneOf:
            - items:
                $ref: '#/components/schemas/FixedFeeQuantityTransition'
              type: array
            - type: 'null'
          title: Fixed Fee Quantity Transitions
          description: >-
            The fixed fee quantity transitions for this price interval. This is
            only relevant for fixed fees.
        current_billing_period_start_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Current Billing Period Start Date
          description: >-
            The start date of the current billing period. This is an inclusive
            timestamp; the instant returned is exactly the beginning of the
            billing period. Set to null if this price interval is not currently
            active.
        current_billing_period_end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Current Billing Period End Date
          description: >-
            The end of the current billing period. This is an exclusive
            timestamp, such that the instant returned is exactly the end of the
            billing period. Set to null if this price interval is not currently
            active.
        filter:
          oneOf:
            - type: string
            - type: 'null'
          title: Filter
          description: An additional filter to apply to usage queries.
        usage_customer_ids:
          oneOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Usage Customer Ids
          description: >-
            A list of customer IDs whose usage events will be aggregated and
            billed under this price interval.
        metric_parameter_overrides:
          oneOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Metric Parameter Overrides
          description: >-
            Override values for parameterized billable metric variables. Keys
            are parameter names, values are the override values.
      type: object
      required:
        - id
        - start_date
        - end_date
        - price
        - billing_cycle_day
        - can_defer_billing
        - fixed_fee_quantity_transitions
        - current_billing_period_start_date
        - current_billing_period_end_date
        - filter
        - usage_customer_ids
      title: PriceInterval
      description: >-
        The Price Interval resource represents a period of time for which a
        price will bill on a subscription. A

        subscription’s price intervals define its billing behavior.
    AdjustmentInterval:
      properties:
        id:
          type: string
          title: Id
        adjustment:
          $ref: '#/components/schemas/Adjustment'
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the adjustment interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the adjustment interval.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval IDs that this adjustment applies to.
      type: object
      required:
        - id
        - adjustment
        - start_date
        - end_date
        - applies_to_price_interval_ids
      title: AdjustmentInterval
    AmountDiscountInterval:
      properties:
        discount_type:
          type: string
          enum:
            - amount
          title: Discount Type
        amount_discount:
          type: string
          title: Amount Discount
          description: Only available if discount_type is `amount`.
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the discount interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the discount interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this discount interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this discount interval applies to.
      type: object
      required:
        - discount_type
        - amount_discount
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
      title: AmountDiscountInterval
    PercentageDiscountInterval:
      properties:
        discount_type:
          type: string
          enum:
            - percentage
          title: Discount Type
        percentage_discount:
          type: number
          title: Percentage Discount
          description: >-
            Only available if discount_type is `percentage`.This is a number
            between 0 and 1.
          examples:
            - 0.15
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the discount interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the discount interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this discount interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this discount interval applies to.
      type: object
      required:
        - discount_type
        - percentage_discount
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
      title: PercentageDiscountInterval
    UsageDiscountInterval:
      properties:
        discount_type:
          type: string
          enum:
            - usage
          title: Discount Type
        usage_discount:
          type: number
          title: Usage Discount
          description: >-
            Only available if discount_type is `usage`. Number of usage units
            that this discount is for
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the discount interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the discount interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this discount interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this discount interval applies to.
      type: object
      required:
        - discount_type
        - usage_discount
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
      title: UsageDiscountInterval
    TieredPercentageDiscountInterval:
      properties:
        discount_type:
          type: string
          enum:
            - tiered_percentage
          title: Discount Type
        tiers:
          items:
            $ref: '#/components/schemas/PercentageTier'
          type: array
          title: Tiers
          description: >-
            Only available if discount_type is `tiered_percentage`. The ordered,
            contiguous bands of cumulative eligible spend, each discounted at
            its own percentage.
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the discount interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the discount interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this discount interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this discount interval applies to.
      type: object
      required:
        - discount_type
        - tiers
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
      title: TieredPercentageDiscountInterval
    MinimumInterval:
      properties:
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the minimum interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the minimum interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this minimum interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this minimum interval applies to.
        minimum_amount:
          type: string
          title: Minimum Amount
          description: >-
            The minimum amount to charge in a given billing period for the price
            intervals this minimum applies to.
      type: object
      required:
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
        - minimum_amount
      title: MinimumInterval
    MaximumInterval:
      properties:
        start_date:
          type: string
          format: date-time
          title: Start Date
          description: The start date of the maximum interval.
        end_date:
          oneOf:
            - type: string
              format: date-time
            - type: 'null'
          title: End Date
          description: The end date of the maximum interval.
        filters:
          items:
            $ref: '#/components/schemas/PriceFilter'
          type: array
          title: Filters
          description: >-
            The filters that determine which prices this maximum interval
            applies to.
        applies_to_price_interval_ids:
          items:
            type: string
          type: array
          title: Applies To Price Interval Ids
          description: The price interval ids that this maximum interval applies to.
        maximum_amount:
          type: string
          title: Maximum Amount
          description: >-
            The maximum amount to charge in a given billing period for the price
            intervals this transform applies to.
      type: object
      required:
        - start_date
        - end_date
        - filters
        - applies_to_price_interval_ids
        - maximum_amount
      title: MaximumInterval
    SubscriptionChangeMinified:
      properties:
        id:
          type: string
          title: Id
      type: object
      required:
        - id
      title: SubscriptionChangeMinified
    ChangedSubscriptionResources:
      properties:
        created_credit_notes:
          items:
            $ref: '#/components/schemas/CreditNote'
          type: array
          title: Created Credit Notes
          description: The credit notes that were created as part of this operation.
        voided_credit_notes:
          items:
            $ref: '#/components/schemas/CreditNote'
          type: array
          title: Voided Credit Notes
          description: The credit notes that were voided as part of this operation.
        created_invoices:
          items:
            $ref: '#/components/schemas/CreatedInvoice'
          type: array
          title: Created Invoices
          description: The invoices that were created as part of this operation.
        voided_invoices:
          items:
            $ref: '#/components/schemas/Invoice'
          type: array
          title: Voided Invoices
          description: The invoices that were voided as part of this operation.
      type: object
      required:
        - created_credit_notes
        - voided_credit_notes
        - created_invoices
        - voided_invoices
      title: ChangedSubscriptionResources
    ConstraintViolationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-constraint-violation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ConstraintViolationError
    DuplicateResourceCreationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-duplicate-resource-creation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: DuplicateResourceCreationError
    RequestValidationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-request-validation-errors
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
        validation_errors:
          items: {}
          type: array
          title: Validation Errors
      type: object
      required:
        - type
        - status
        - validation_errors
      title: RequestValidationError
    AuthorizationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#401-authentication-error
          title: Type
        status:
          type: integer
          enum:
            - 401
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: AuthorizationError
    FeatureNotAvailableError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-feature-not-available
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: FeatureNotAvailableError
    ResourceNotFoundError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-resource-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          type: string
          title: Title
      type: object
      required:
        - type
        - status
        - title
      title: ResourceNotFoundError
    URLNotFound:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-url-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: URLNotFound
    IdempotencyRequestMismatch:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#409-resource-conflict
          title: Type
        status:
          type: integer
          enum:
            - 409
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: IdempotencyRequestMismatch
    RequestTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-request-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: RequestTooLargeError
    ResourceTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-resource-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ResourceTooLargeError
    TooManyResultsError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-too-many-results
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyResultsError
    TooManyRequests:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#429-too-many-requests
          title: Type
        status:
          type: integer
          enum:
            - 429
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyRequests
    ServerError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#500-internal-server-error
          title: Type
        status:
          type: integer
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ServerError
    NewSubscriptionPrice:
      oneOf:
        - $ref: '#/components/schemas/NewSubscriptionUnitPrice'
        - $ref: '#/components/schemas/NewSubscriptionTieredPrice'
        - $ref: '#/components/schemas/NewSubscriptionBulkPrice'
        - $ref: '#/components/schemas/NewSubscriptionBulkWithFiltersPrice'
        - $ref: '#/components/schemas/NewSubscriptionPackagePrice'
        - $ref: '#/components/schemas/NewSubscriptionMatrixPrice'
        - $ref: '#/components/schemas/NewSubscriptionThresholdTotalAmountPrice'
        - $ref: '#/components/schemas/NewSubscriptionTieredPackagePrice'
        - $ref: '#/components/schemas/NewSubscriptionTieredWithMinimumPrice'
        - $ref: '#/components/schemas/NewSubscriptionGroupedTieredPrice'
        - $ref: '#/components/schemas/NewSubscriptionTieredPackageWithMinimumPrice'
        - $ref: '#/components/schemas/NewSubscriptionPackageWithAllocationPrice'
        - $ref: '#/components/schemas/NewSubscriptionUnitWithPercentPrice'
        - $ref: '#/components/schemas/NewSubscriptionMatrixWithAllocationPrice'
        - $ref: >-
            #/components/schemas/NewSubscriptionMatrixWithThresholdDiscountsPrice
        - $ref: '#/components/schemas/NewSubscriptionTieredWithProrationPrice'
        - $ref: '#/components/schemas/NewSubscriptionUnitWithProrationPrice'
        - $ref: '#/components/schemas/NewSubscriptionGroupedAllocationPrice'
        - $ref: '#/components/schemas/NewSubscriptionBulkWithProrationPrice'
[...]
